import { ServiceFactory } from "app/services/service-factory";
import { PbCloison, PreBarrage } from "jalhyd";
import { SelectEntry } from "./select-entry";
import { SelectField } from "./select-field";

/*
    "id": "select_downstream_basin",
    "type": "select_custom",
    "source": "downstream_basin"
*/    

// PbCloisons, bassin aval
export class SelectFieldDownstreamBasin extends SelectField {
    protected populate() {
        const pbWallD = this.parentForm.currentNub as PbCloison;
        const preBarrageD = pbWallD.parent as PreBarrage;
        const posUb = pbWallD.bassinAmont?.findPositionInParent();
        // all available basins, depending on current upstream basin
        for (const b of preBarrageD.bassins) {
            const pos = b.findPositionInParent();
            if (posUb === undefined || pos > posUb) {
                this.addEntry(
                    new SelectEntry(
                        this._entriesBaseId + b.uid,
                        b.uid,
                        ServiceFactory.i18nService.localizeMessage(b.description)
                    )
                );
            }
        }
        // river downstream
        this.addEntry(
            new SelectEntry(
                this._entriesBaseId + "none",
                undefined,
                ServiceFactory.i18nService.localizeText("INFO_LIB_AVAL")
            )
        );
    }

    protected initSelectedValue() {
        const db = (this.nub as PbCloison).bassinAval;
        this.setValueFromId(this._entriesBaseId + (db ? db.uid : "none"));
    }
}
